# Tutorial

:project Programming

## Introduction

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Programming

In this tutorial course, we will learn about programming in **microScript**.

Click button "next" to continue:

:navigate projects.code.console

:highlight #tutorial-window .navigation .next

## Console

:navigate projects.code.console

:position 60,30,40,50

### Console

As an introduction to programming, we will play with the microStudio console.
The console allows to converse with the computer by typing text (code) and reading
computer's answers.

:highlight #terminal

## Console input

:navigate projects.code.console

To start programming, click on the input area of the console (highlighted).

:highlight #terminal-input-line

:auto

## Type a word

:navigate projects.code.console

### Type a word

Type in a word with your keyboard, like:

```
hello
```

Then validate your input by pressing key [Return] or [⏎].

:auto #terminal-input

## Answer

:navigate projects.code.console

If you typed ```hello```, microScript has answered with ```0```.

Don't be upset, the computer didn't mean to be rude! A computer is not
as smart as you think. It can work hard, yet it needs you to express
exactly what you expect from it.

Programming means telling the computer what to do, using a language it can
understand.

## Answer 2

:navigate projects.code.console

The computer answered with ```0``` because it doesn't know ```hello```. It
did search its memory for a *variable* which would be called that, but didn't
find anything.

It thus answered ```0``` which for it also means nothing, not found, unknown.
Let's try to teach it something, type:

```
hello = 5
```

:auto #terminal-input

## Assign a value to a variable

:navigate projects.code.console

By validating this line, we just *assigned* the value ```5``` to the *variable* ```hello```.
The computer created a cell in its memory, labelled "hello" and in which it stored
the value 5.

Now we can ask it again:

```
hello
```

The console answers 5! It seems it finally learnt something.

## Making calculations

:navigate projects.code.console

Can it even count though? Let's try:

```
1+1
```

Impressive isn't it? Now:

```
hello*2
```

OK now this is something, it seems it can use its memory and make calculations
*simultaneously*.
We can certainly get something out of it. It's time to move on to the
next tutorial to learn more about variables.
